unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Image1: TImage;
    Label1: TLabel;
    Edit1: TEdit;
    Label2: TLabel;
    Edit2: TEdit;
    Label3: TLabel;
    Edit3: TEdit;
    Label4: TLabel;
    Edit4: TEdit;
    Label5: TLabel;
    Edit5: TEdit;
    Label6: TLabel;
    Edit6: TEdit;
    Label7: TLabel;
    Edit7: TEdit;
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

var infini,re_min,re_max,Im_min,Im_max,x:real;
    calprof,desprof:integer;

function Color(n:integer):TColor;
begin
  case n of
  0:result:=clInfoBk;
  1:result:=clBlack;
  2:result:=clMaroon;
  3:result:=clGreen;
  4:result:=clOlive;
  5:result:=clNavy;
  6:result:=clPurple;
  7:result:=clTeal;
  8:result:=clGray;
  9:result:=clSilver;
  10:result:=clRed;
  11:result:=clLime;
  12:result:=clYellow;
  13:result:=clBlue;
  14:result:=clFuchsia;
  15:result:=clAqua;
  16:result:=clLtGray;
  17:result:=clDkGray;
  18:result:=clWhite;
  end;
end;

procedure Dessine;
var large,haut,iimag,ireal,prof:integer; dreal,dimag,lreal,limag,re,im,xx,yy:real;
begin
  large:=Form1.Image1.Width;
  haut:=Form1.Image1.Height;
  Form1.Image1.Canvas.Brush.Style:=bsSolid;
  Form1.Image1.Canvas.Brush.Color:=clWhite;
  Form1.Image1.Canvas.Rectangle(0,0,large,haut);
  dreal:=(re_max-re_min)/large;
  dimag:=(im_max-im_min)/haut;
  FOR iimag:= 0 TO haut-1 do
    FOR ireal:= 0 TO large -1 do begin
      lreal:=re_min+ireal*dreal;
      limag:=im_min+iimag*dimag;
      re:=lreal;
      im:=limag;
      prof:=0;
      REPEAT
        xx:=re*re;
        yy:=im*im;
        im:=2*re*im-limag;
        re:=xx-yy-lreal;
        inc(prof);
      UNTIL (prof=calprof) OR (xx+yy>infini);
      IF prof<calprof then begin
        IF prof>desprof then Form1.Image1.Canvas.Pixels[ireal,iimag]:=color(prof mod 19)
        ELSE IF ((prof MOD 2)=0) then Form1.Image1.Canvas.Pixels[ireal,iimag]:=color(prof mod 19);
      end;
    end; //next ireal
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
     infini:=StrToFloat(Edit5.Text);  // le nombre que l'on considre comme "infini" (seuil de divergence)
     calprof:=StrToInt(Edit6.Text);   // profondeur de calcul (nombre d'itrations pour tester la convergence)
     desprof:=StrToInt(Edit7.Text);   // profondeur de dessin (nb de couleurs utilises)
     re_min:=StrToFloat(Edit1.Text);  // x min
     re_max:=StrToFloat(Edit2.Text);  // x max
     Im_min:=StrToFloat(Edit3.Text);  // y min
     Im_max:=StrToFloat(Edit4.Text);  // y max
     if infini<=0 then infini:=10;
     if calprof<=0 then calprof:=20;
     if desprof<=0 then desprof:=10;
     if re_min>re_max then
        begin
        x:=re_min;
        re_min:=re_max;
        re_max:=x;
        end;
     if Im_min>Im_max then
        begin
        x:=Im_min;
        Im_min:=Im_max;
        Im_max:=x;
        end;
     Screen.Cursor:=crHourGlass;
     Dessine;
     Screen.Cursor:=crDefault;
end;

end.
